Subject: Re: bug#61255: [PATCH 0/5] Add support for the RPM format to "guix pack"

From: Ludovic Courtès <[email-masked]>
Date: Sun, 12 Feb 2023 19:14:57 +0100

Hi Maxim,

Maxim Cournoyer <[email-masked]> skribis:

> Ludovic Courtès <[email-masked]> writes:
>
>> Hello!
>>
>> Maxim Cournoyer <[email-masked]> skribis:
>>
>>> * guix/gexp.scm (computed-file): Set the default value of the #:guile argument
>>> to that of the %guile-for-build parameter.
>>
>> [...]
>>
>>>  (define* (computed-file name gexp
>>> -                        #:key guile (local-build? #t) (options '()))
>>> +                        #:key (guile (%guile-for-build))
>>> +                        (local-build? #t) (options '()))
>>
>> I think that would lead ‘computed-file’ to pick (%guile-for-build) at
>> the wrong time (time of call instead of time of lowering).
>>
>> Commit ab25eb7caaf5571cc9f8d6397a1eae127d7e29d1 made it #f such that
>> ‘gexp->derivation’ gets to resolve it at the “right” time.
>
> I see!  I think you are right.  Would making the change in the
> associated gexp compiler do the right thing?  Currently it ignores the
> %guile-for-build fluid as set in the tests/pack.scm test suite for
> example.  Something like this:

I don’t fully understand the context.  My preference would go to doing
like the ‘computed-file’ tests in ‘tests/gexp.scm’, where we explicitly
pass #:guile %bootstrap-guile.

That said, it seems like patch #5 in this series doesn’t actually use
‘computed-file’ in ‘tests/pack.scm’, does it?

Thanks,
Ludo’, slowly catching up post-FOSDEM!